#1517 closed defect (fixed)

mount does not use the provided filesystem handler table functions

Reported by: Bharath Suri Owned by: Chris Johns
Priority: normal Milestone: 4.10
Component: fs Version: 4.10
Severity: normal Keywords:
Cc: sebastian.huber@… Blocked By:
Blocking:

Description

The code:
mount(&mt_entry, &IMFS_ops_modified,
RTEMS_FILESYSTEM_READ_WRITE, NULL, "/imfs");

is supposed to mount a filesystem

  • at /imfs
  • filesystem handler table functions from &IMFS_ops_modified
  • with options = RTEMS_FILESYSTEM_READ_WRITE
  • device type = NULL and
  • and should fill the mt_entry with appropriate mount table entry value

and all operations involving the filesystem handler functions under this newly mounted filesystem need to use the provided handler functions (during mount)

Error:
The mount call does seem to consider the provided handler function table. Instead,

if IMFS_ops_modified.fsmount_me_h is IMFS_initialize, the handlers associated with mt_entry would be set to IMFS_ops (see imfs_init.c)

similar pattern was seen for the dosfs too

The above behaviour was seen during coverage improvement while exercising the _rename_r function in the libcsupport.

Attached is the original source file. Line 150 and 426 need to be looked into for details of operation.

Attachments (1)

test.c (17.3 KB) - added by Bharath Suri on May 14, 2010 at 3:11:45 PM.
File from rtems/testsuites/psxtests/psxfile01/test.c

Download all attachments as: .zip

Change History (6)

Changed on May 14, 2010 at 3:11:45 PM by Bharath Suri

Attachment: test.c added

File from rtems/testsuites/psxtests/psxfile01/test.c

comment:1 Changed on May 16, 2010 at 11:41:38 PM by Joel Sherrill

Owner: changed from Joel Sherrill to Chris Johns

comment:2 Changed on May 16, 2010 at 11:47:00 PM by Chris Johns

Status: newassigned

comment:3 Changed on May 17, 2010 at 6:21:00 AM by Sebastian Huber

Cc: Sebastian Huber added

comment:4 Changed on Jun 2, 2010 at 12:08:46 AM by Chris Johns

Resolution: fixed
Status: assignedclosed

comment:5 Changed on Jun 8, 2010 at 10:22:16 AM by Chris Johns

Yes the rename should happen. The same with the NFSFS. We need a 4.10 patch as well.

Note: See TracTickets for help on using tickets.